---
title: Node.replaceChild()
slug: Web/API/Node/replaceChild
tags:
  - API
  - DOM
  - Method
  - Node
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>Node.replaceChild()</code></strong> method replaces a child node within the given (parent) node.</p>

<p>Note the idiosyncratic argument order (new before old). <code><a href="/en-US/docs/Web/API/ChildNode/replaceWith">ChildNode.replaceWith()</a></code> may be easier to read and use.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>let oldChild = parentNode</em>.replaceChild(<em>newChild</em>, <em>oldChild</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><strong>newChild</strong></dt>
	<dd>The new node to replace <code>oldChild</code>. If it already exists in the DOM, it is first removed.</dd>
	<dt><strong>oldChild</strong></dt>
	<dd>The child to be replaced.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The returned value is the replaced node. This is the same node as <code>oldChild</code>.</p>

<h2 id="Example">Example</h2>

<pre class="brush:js notranslate">// Given:
// &lt;div&gt;
//  &lt;span id="childSpan"&gt;foo bar&lt;/span&gt;
// &lt;/div&gt;

// Create an empty element node
// without an ID, any attributes, or any content
var sp1 = document.createElement("span");

// Give it an id attribute called 'newSpan'
sp1.id = "newSpan";

// Create some content for the new element.
var sp1_content = document.createTextNode("new replacement span element.");

// Apply that content to the new element
sp1.appendChild(sp1_content);

// Build a reference to the existing node to be replaced
var sp2 = document.getElementById("childSpan");
var parentDiv = sp2.parentNode;

// Replace existing node sp2 with the new span element sp1
parentDiv.replaceChild(sp1, sp2);

// Result:
// &lt;div&gt;
//   &lt;span id="newSpan"&gt;new replacement span element.&lt;/span&gt;
// &lt;/div&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("DOM WHATWG", "#dom-node-replacechild", "Node: replaceChild")}}</td>
			<td>{{Spec2("DOM WHATWG")}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Node.replaceChild")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("Node.removeChild")}}</li>
	<li>{{domxref("ChildNode.replaceWith")}}</li>
</ul>
